<?php class diffractionrequest extends baseobject { 
	
	protected static $fields=array(
		'name'=>validator::REQUIRED,
		'crystalid'=>array(validator::REQUIRED, validator::INTEGER),
		'shipmentid'=>validator::INTEGER,
	    'diffractiontype'=>validator::ANY,
	    'observedresolution'=>validator::FLOAT,
	    'requiredresolution'=>validator::FLOAT,
	    'minimumresolution'=>validator::FLOAT,
	    'comment'=>validator::ANY,
	);
	
	protected static $helpTexts=array(
		'name'=>'The name of the shipment destination',
		'crystalid'=>'The ID of the crystal to which this comment relates',
		'shipmentid'=>'The ID of the shipment - crystal may be shipped several times with different comments',
	    'diffractiontype'=>'',
	    'observedresolution'=>'',
	    'requiredresolution'=>'',
	    'minimumresolution'=>'',
	    'comment'=>'Free-text comments',
	);
	
	public static function create($request=array()){
		$crystal=crystal::getById($request['crystalid']);
		$request['projectid']=$crystal['projectid'];
		$request['name']='crystal'.$crystal['id'].'_diffreq_'.microtime();
		
		//Doing this in code, not as a database default, in case non-ispyb synchrotrons require changes later
		$request['diffractiontype']='OSC';
		
		return parent::create($request);
	}
	
}

?>